Getting Started with Window Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Window module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.window.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-window id="window"></smart-window>

    Host container (id matches appendTo on Smart.Window):

    <div id="windowContainer"></div>

  5. Initialize after the module loads: define a const windowOptions object, then either bind with Smart('#window', ...) on the semantic tag or use new Smart.Window({ ...windowOptions, appendTo: '#windowContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.window.js';
    
    	const windowOptions = { opened: true };
    
    	// Option A - semantic <smart-window> with id="window"
    	Smart('#window', class {
    		get properties() {
    			return windowOptions;
    		}
    	});
    
    	// Option B - host div id="windowContainer"
    	// const windowInstance = new Smart.Window({
    	// 	...windowOptions,
    	// 	appendTo: '#windowContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myWindow = new Smart.Window('#window', windowOptions);
    	// document.body.appendChild(myWindow);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Window('#window', windowOptions) with appendChild, and document.createElement('smart-window') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Window({ ...options, appendTo: '#...' }); new Smart.Window('#window', windowOptions) plus appendChild on the returned element; and document.createElement('smart-window') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myWindow = new Smart.Window('#window', windowOptions)):

	const windowOptions = { opened: true };
	const myWindow = new Smart.Window('#window', windowOptions);
	document.body.appendChild(myWindow);
	

Create with document.createElement('smart-window'), assign properties (same as any custom element), then append:

	const windowOptions = { opened: true };
	const window = document.createElement('smart-window');
	Object.assign(window, windowOptions);
	document.body.appendChild(window);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.window.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const windowOptions = { opened: true };
		const window = new Smart.Window({
			...windowOptions,
			appendTo: '#windowContainer'
		});
	}
	

Append to the DOM:

const container = document.getElementById('window-container');
container.appendChild(window);
	

Remove from the DOM:

window.remove();
	

Set a property:

window.disabled = true;
window.theme = 'dark';
	

Get a property value:

const isDisabled = window.disabled;
const currentTheme = window.theme;
	

Invoke a method:

window.refresh();
window.focus();
	

Add event listener:

window.addEventListener('open', (event) => {
    console.log('open triggered:', event.detail);
});
	

Remove event listener:

const handleWindowEvent = (event) => {
    console.log('open triggered:', event.detail);
};

window.addEventListener('open', handleWindowEvent);
window.removeEventListener('open', handleWindowEvent);
	

Common Use Cases

  • Open modal dialog

    Show window as a modal overlay

    window.modal = true;
    window.open();
  • Handle close event

    Execute code when window closes

    smartWindow.addEventListener('close', () => {
      console.log('Window closed');
    });

Troubleshooting

How do I center the window?
Use windowParent = 'body' and set centered = true, or calculate position manually using viewport dimensions.
How do I prevent the window from being closed?
Handle the closing event and call e.preventDefault() to cancel the close action.

Accessibility

The Window component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Window - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/window/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import WindowModule from smart-webcomponents-angular/window: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { WindowModule } from 'smart-webcomponents-angular/window';

4 Root component (standalone)

Add WindowModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { ButtonComponent } from 'smart-webcomponents-angular/button';
import { WindowComponent } from 'smart-webcomponents-angular/window';

import { ButtonModule } from 'smart-webcomponents-angular/button';

import { WindowModule } from 'smart-webcomponents-angular/window';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ButtonModule, WindowModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('button', { read: ButtonComponent, static: false }) button!: ButtonComponent;
	@ViewChild('window', { read: WindowComponent, static: false }) smartWindow!: WindowComponent;
	
	onButtonClick(event:any): void {
		const smartWindow = this.smartWindow;

		smartWindow.opened ? smartWindow.close() : smartWindow.open();
	}

	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-window as needed:

 <smart-button #button (onClick)="onButtonClick($event)" id="openButton">Open/Close</smart-button>
<smart-window #window [opened]="true" [label]="'Window 1'">
    <div id="article">
        <section>
             <h3>What is Lorem Ipsum?</h3>
            <p>Lorem Ipsum is simply dummy text of the printing and typesetting industry.
                Lorem Ipsum has been the industry's standard dummy text ever since the
                1500s, when an unknown printer took a galley of type and scrambled it to
                make a type specimen book. It has survived not only five centuries, but
                also the leap into electronic typesetting, remaining essentially unchanged.
                It was popularised in the 1960s with the release of Letraset sheets containing
                Lorem Ipsum passages, and more recently with desktop publishing software
                like Aldus PageMaker including versions of Lorem Ipsum.</p>
        </section>
        <section>
             <h3>Where does it come from?</h3>
            <p>Contrary to popular belief, Lorem Ipsum is not simply random text. It
                has roots in a piece of classical Latin literature from 45 BC, making it
                over 2000 years old. Richard McClintock, a Latin professor at Hampden-Sydney
                College in Virginia, looked up one of the more obscure Latin words, consectetur,
                from a Lorem Ipsum passage, and going through the cites of the word in
                classical literature, discovered the undoubtable source. Lorem Ipsum comes
                from sections 1.10.32 and 1.10.33 of "de Finibus Bonorum et Malorum" (The
                Extremes of Good and Evil) by Cicero, written in 45 BC. This book is a
                treatise on the theory of ethics, very popular during the Renaissance.
                The first line of Lorem Ipsum, "Lorem ipsum dolor sit amet..", comes from
                a line in section 1.10.32. The standard chunk of Lorem Ipsum used since
                the 1500s is reproduced below for those interested. Sections 1.10.32 and
                1.10.33 from "de Finibus Bonorum et Malorum" by Cicero are also reproduced
                in their exact original form, accompanied by English versions from the
                1914 translation by H. Rackham.</p>
        </section>
    </div>
</smart-window>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put WindowModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put WindowModule from smart-webcomponents-angular/window on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { WindowModule } from 'smart-webcomponents-angular/window';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, WindowModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Open modal dialog

    Show window as a modal overlay

    window.modal = true;
    window.open();
  • Handle close event

    Execute code when window closes

    smartWindow.addEventListener('close', () => {
      console.log('Window closed');
    });

Troubleshooting

How do I center the window?
Use windowParent = 'body' and set centered = true, or calculate position manually using viewport dimensions.
How do I prevent the window from being closed?
Handle the closing event and call e.preventDefault() to cancel the close action.

Accessibility

The Window component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Window Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/window/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React,  { useState, useRef, useEffect } from "react";
import ReactDOM from 'react-dom/client';
import { Window } from 'smart-webcomponents-react/window';
import { Button } from 'smart-webcomponents-react/button';
export default function App() {
    const testalert = () => {
        alert("Hello");
    }
	
	  const buttonInput = useRef(null);
	  useEffect(() => {
    // Update the document title using the browser API
		buttonInput.current.onclick = testalert;
  });

return (
                <Window windowParent='body' opened label="Window 1">
                    <Button onClick={testalert}>jQWidgets button</Button>
                    <button ref={buttonInput}
                        type="button"
                        onClick={

                            testalert

                        }
                    >
                        <span>Html Button</span>
                    </button>
                </Window>
  )
};

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Open modal dialog

    Show window as a modal overlay

    window.modal = true;
    window.open();
  • Handle close event

    Execute code when window closes

    smartWindow.addEventListener('close', () => {
      console.log('Window closed');
    });

Troubleshooting

How do I center the window?
Use windowParent = 'body' and set centered = true, or calculate position manually using viewport dimensions.
How do I prevent the window from being closed?
Handle the closing event and call e.preventDefault() to cancel the close action.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Window, WindowProps } from 'smart-webcomponents-react/window';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Window component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.